using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine;
using UnityEngine.SceneManagement;
using System.Linq;
using TMPro;
using UnityEngine.UI;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {      
	CategoryBuilder.Create(" Press Mod", "", ModAPI.LoadSprite("category icon.png"));       







ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[Press] Vest Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3a",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vestv3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest1n.png", 12); 

                        var Vest = new GameObject("Vest");
                        Vest.transform.SetParent(Instance.transform);
                        Vest.transform.localPosition = new Vector2(0f, 0f);
                        Vest.transform.localScale = new Vector3(1f, 1f);
                        Vest.transform.rotation = Instance.transform.rotation;
                        var VestSprite = Vest.AddComponent<SpriteRenderer>();
                        VestSprite.sprite = ModAPI.LoadSprite("Armor/vest1n2.png", 12f);
                        VestSprite.sortingLayerName = "Top"; 

                        int PartCount = 3;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);   

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest1n.png", 12f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest1v2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        armProp[1].sprite = ModAPI.LoadSprite("Armor/vest1.png", 12);
                        armProp[1].armorPiece = "UpperBody";
                        armProp[1].offset = offset;
                        armProp[1].armorTier = 1;
                        armProp[1].scaleOffset = scaleOffset;
                        armProp[1].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[Press] Vest Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3b",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vestv2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest2.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest2.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest2v2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[Press] Vest Variant 3", 
                    DescriptionOverride = "eft", 
                    NameToOrderByOverride = "3c",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vestv1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest3n.png", 12); 

                        var Vest = new GameObject("Vest");
                        Vest.transform.SetParent(Instance.transform);
                        Vest.transform.localPosition = new Vector2(0f, 0f);
                        Vest.transform.localScale = new Vector3(1f, 1f);
                        Vest.transform.rotation = Instance.transform.rotation;
                        var VestSprite = Vest.AddComponent<SpriteRenderer>();
                        VestSprite.sprite = ModAPI.LoadSprite("Armor/vest3n2.png", 12f);
                        VestSprite.sortingLayerName = "Top"; 

                        int PartCount = 3;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);   

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest3n.png", 12f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest3v2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        armProp[1].sprite = ModAPI.LoadSprite("Armor/vest3.png", 12);
                        armProp[1].armorPiece = "UpperBody";
                        armProp[1].offset = offset;
                        armProp[1].armorTier = 1;
                        armProp[1].scaleOffset = scaleOffset;
                        armProp[1].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Press] Badge Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3d",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/badgeicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/badge.png", 12f);

                        var Badge = new GameObject("Badge");
                        Badge.transform.SetParent(Instance.transform);
                        Badge.transform.localPosition = new Vector2(0f, 0f);
                        Badge.transform.localScale = new Vector3(1f, 1f);
                        Badge.transform.rotation = Instance.transform.rotation;
                        var BadgeSprite = Badge.AddComponent<SpriteRenderer>();
                        BadgeSprite.sprite = ModAPI.LoadSprite("Armor/badgen.png", 12f);
                        BadgeSprite.sortingLayerName = "Bottom"; 
 
                        int PartCount = 1;

                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f); 

                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "LowerBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/badge.png", 12f);
                        prop.armorPoints = 2;
                        prop.offset = offset;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Press] Badge Variant 2", 
                    DescriptionOverride = "eft", 
                    NameToOrderByOverride = "3e",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/badge2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/badge2.png", 12f);

                        var Badge = new GameObject("Badge");
                        Badge.transform.SetParent(Instance.transform);
                        Badge.transform.localPosition = new Vector2(0f, 0f);
                        Badge.transform.localScale = new Vector3(1f, 1f);
                        Badge.transform.rotation = Instance.transform.rotation;
                        var BadgeSprite = Badge.AddComponent<SpriteRenderer>();
                        BadgeSprite.sprite = ModAPI.LoadSprite("Armor/badgen.png", 12f);
                        BadgeSprite.sortingLayerName = "Bottom"; 
 
                        int PartCount = 1;

                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f); 

                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "LowerBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/badge2.png", 12f);
                        prop.armorPoints = 2;
                        prop.offset = offset;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );


ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Press] Helmet Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2a",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv1.png", 12f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv1.png", 12f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Press] Helmet Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2b",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv2.png", 12f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv2.png", 12f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Press] Helmet Variant 3", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2c",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv3.png", 12f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv3.png", 12f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Press] Helmet Variant 4", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2d",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv4icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv4.png", 12f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv4.png", 12f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

////////////////////////////////////////////////////////////////////////

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "[Press] Patch on Helmet [Press (Blue Color)]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4a",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/p1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Patch/patch1.png", 12f);

                        var Patch = new GameObject("Patch");
                        Patch.transform.SetParent(Instance.transform);
                        Patch.transform.localPosition = new Vector2(0f, 0f);
                        Patch.transform.localScale = new Vector3(1f, 1f);
                        Patch.transform.rotation = Instance.transform.rotation;
                        var PatchSprite = Patch.AddComponent<SpriteRenderer>();
                        PatchSprite.sprite = ModAPI.LoadSprite("Patch/patch1.png", 12f);
                        PatchSprite.sortingLayerName = "Top"; 
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Patch/patch1.png", 12f);
                        prop.armorPoints = 10;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "[Press] Patch on Helmet [Press (Tan Color)]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4b",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/p2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Patch/patch2.png", 12f);
 
                        var Patch = new GameObject("Patch");
                        Patch.transform.SetParent(Instance.transform);
                        Patch.transform.localPosition = new Vector2(0f, 0f);
                        Patch.transform.localScale = new Vector3(1f, 1f);
                        Patch.transform.rotation = Instance.transform.rotation;
                        var PatchSprite = Patch.AddComponent<SpriteRenderer>();
                        PatchSprite.sprite = ModAPI.LoadSprite("Patch/patch2.png", 12f);
                        PatchSprite.sortingLayerName = "Top"; 

                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Patch/patch2.png", 12f);
                        prop.armorPoints = 10;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "[Press] Patch on Helmet [Press (Green Color)]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4c",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/p3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Patch/patch3.png", 12f);

                        var Patch = new GameObject("Patch");
                        Patch.transform.SetParent(Instance.transform);
                        Patch.transform.localPosition = new Vector2(0f, 0f);
                        Patch.transform.localScale = new Vector3(1f, 1f);
                        Patch.transform.rotation = Instance.transform.rotation;
                        var PatchSprite = Patch.AddComponent<SpriteRenderer>();
                        PatchSprite.sprite = ModAPI.LoadSprite("Patch/patch3.png", 12f);
                        PatchSprite.sortingLayerName = "Top"; 
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Patch/patch3.png", 12f);
                        prop.armorPoints = 10;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "[Press] Patch on Helmet [Press Journalist (Blue Color)]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4d",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/p4icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Patch/patch4.png", 12f);

                        var Patch = new GameObject("Patch");
                        Patch.transform.SetParent(Instance.transform);
                        Patch.transform.localPosition = new Vector2(0f, 0f);
                        Patch.transform.localScale = new Vector3(1f, 1f);
                        Patch.transform.rotation = Instance.transform.rotation;
                        var PatchSprite = Patch.AddComponent<SpriteRenderer>();
                        PatchSprite.sprite = ModAPI.LoadSprite("Patch/patch4.png", 12f);
                        PatchSprite.sortingLayerName = "Top"; 
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Patch/patch4.png", 12f);
                        prop.armorPoints = 10;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "[Press] Patch on Helmet [Press Journalist (Tan Color)]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4e",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/p5icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Patch/patch5.png", 12f);

                        var Patch = new GameObject("Patch");
                        Patch.transform.SetParent(Instance.transform);
                        Patch.transform.localPosition = new Vector2(0f, 0f);
                        Patch.transform.localScale = new Vector3(1f, 1f);
                        Patch.transform.rotation = Instance.transform.rotation;
                        var PatchSprite = Patch.AddComponent<SpriteRenderer>();
                        PatchSprite.sprite = ModAPI.LoadSprite("Patch/patch5.png", 12f);
                        PatchSprite.sortingLayerName = "Top"; 
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Patch/patch5.png", 12f);
                        prop.armorPoints = 10;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "[Press] Patch on Helmet [Press Journalist (Green Color)]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4f",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/p6icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Patch/patch6.png", 12f);

                        var Patch = new GameObject("Patch");
                        Patch.transform.SetParent(Instance.transform);
                        Patch.transform.localPosition = new Vector2(0f, 0f);
                        Patch.transform.localScale = new Vector3(1f, 1f);
                        Patch.transform.rotation = Instance.transform.rotation;
                        var PatchSprite = Patch.AddComponent<SpriteRenderer>();
                        PatchSprite.sprite = ModAPI.LoadSprite("Patch/patch6.png", 12f);
                        PatchSprite.sortingLayerName = "Top"; 
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Patch/patch6.png", 12f);
                        prop.armorPoints = 10;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

/////////////////////////////////////////////////////////////

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[Press] Variant 1",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1a",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/v1icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 1.png"),
                            ModAPI.LoadTexture("Outfit/Variant 1v2.png"),
                            ModAPI.LoadTexture("Outfit/Variant 1v3.png"),
                        };
                    }
                }
            );  
  
 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[Press] Variant 2",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1b",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/v2icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 2.png"),
                            ModAPI.LoadTexture("Outfit/Variant 2v2.png"),
                        };
                    }
                }
            );    

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[Press] Variant 3",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1c",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/v3icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 3.png"),
                            ModAPI.LoadTexture("Outfit/Variant 3v2.png"),
                        };
                    }
                }
            );    


/////////////////////////////props/////////////////////////////////////


ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Press/Props] Badge Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "5a",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/Badgepropicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Props/Badge.png", 15f);
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Press/Props] Badge Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "5b",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/Badge2propicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Props/Badge2.png", 15f);
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Press/Props] Badge Variant 3", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "5c",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/Badgev2propicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Props/Badgev2.png", 15f);
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Press/Props] Badge Variant 4", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "5d",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/Badgev22propicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Props/Badgev22.png", 15f);
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Press/Props] Sony Handycam FDR-AX53", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "5e",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/ax53icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Props/ax53.png", 15f);
                        var AX53 = new GameObject("AX53");
                        AX53.transform.SetParent(Instance.transform);
                        AX53.transform.localPosition = new Vector2(0f, 0f);
                        AX53.transform.localScale = new Vector3(1f, 1f);
                        AX53.transform.rotation = Instance.transform.rotation;
                        var AX53Sprite = AX53.AddComponent<SpriteRenderer>();
                        AX53Sprite.sprite = ModAPI.LoadSprite("Props/ax53n.png", 15f);
                        AX53Sprite.sortingLayerName = "Top"; 
 
                        AudioSource A = Instance.AddComponent<AudioSource>();
                        A.minDistance = 1;
                        A.maxDistance = 10;




                        int index = 0;
                        AudioClip[] AudioData = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sound/camera on.mp3"),
                        };

                        Instance.FixColliders();

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {
                            A.clip = AudioData[index];
                            A.Play();

                            index++;
                            if (index == AudioData.Length) index = 0;
                        };

                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Press/Props] Sony PXW-Z750", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "5f",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/pxwicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Props/pxw.png", 15f);
                        var PXW = new GameObject("PXW");
                        PXW.transform.SetParent(Instance.transform);
                        PXW.transform.localPosition = new Vector2(0f, 0f);
                        PXW.transform.localScale = new Vector3(1f, 1f);
                        PXW.transform.rotation = Instance.transform.rotation;
                        var PXWSprite = PXW.AddComponent<SpriteRenderer>();
                        PXWSprite.sprite = ModAPI.LoadSprite("Props/pxwn.png", 15f);
                        PXWSprite.sortingLayerName = "Top"; 
 
                        AudioSource A = Instance.AddComponent<AudioSource>();
                        A.minDistance = 1;
                        A.maxDistance = 10;




                        int index = 0;
                        AudioClip[] AudioData = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sound/camera on.mp3"),
                        };

                        Instance.FixColliders();

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {
                            A.clip = AudioData[index];
                            A.Play();

                            index++;
                            if (index == AudioData.Length) index = 0;
                        };

                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Press/Props] Nikon D610", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "5g",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/d610icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Props/d610.png", 15f);
 
                        AudioSource A = Instance.AddComponent<AudioSource>();
                        A.minDistance = 1;
                        A.maxDistance = 10;




                        int index = 0;
                        AudioClip[] AudioData = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sound/d610sound.mp3"),
                        };

                        Instance.FixColliders();

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {
                            A.clip = AudioData[index];
                            A.Play();

                            index++;
                            if (index == AudioData.Length) index = 0;
                        };

                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Press] Hair Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "6a",
                    CategoryOverride = ModAPI.FindCategory(" Press Mod"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/hairv1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/hairv1.png", 12f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/hairv1.png", 12f);
                        prop.armorPoints = 1;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );








        }












public class MultipleSpriteHumanBehaviour : MonoBehaviour
    {
        public Texture2D[] Textures = new Texture2D[0];
        public PersonBehaviour person;
        public int CurrentTexture = -2;
        public int Scale = 3;

        void Start()
        {
            SetTexture();
        }

        public void SetTexture()
        {
            if (Textures.Length == 0)
                return;

            if(CurrentTexture == -2)
            {
                CurrentTexture = UnityEngine.Random.Range(0, Textures.Length);
            }
            person.SetBodyTextures(Textures[CurrentTexture], null, null, Scale);
            for (int i = 0; i < person.Limbs.Length; i++)
            {
                person.Limbs[i].gameObject.GetComponent<PhysicalBehaviour>().RefreshOutline();
            }
        }
}    }
}
